﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using Newtonsoft.Json.Linq;

namespace SignatureManagement
{
    class SignatureManagement
    {
        private static string key = "api_key";
        private static string url = "https://sandbox.esignlive.com/api";
        
        public static void Main(string[] args)
        {
            string packageId = "zEDhSfD4emU-bf0_2Zf2SGO_WdY=";
            String documentId = "b56aff1b072892b1";

            //Add approval

            string jsonString = "{\"role\":\"Signer1\",\"id\":\"signature1\",\"fields\":[{\"top\":510,\"left\":215,\"width\":200,\"height\":50,\"page\":0,\"type\":\"SIGNATURE\",\"subtype\":\"FULLNAME\"}]}";
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", key);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/" + packageId + "/documents/" + documentId + "/approvals", jsonContent).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);

            //Update approval

            string jsonString2 = "{\"role\":\"Signer1\",\"fields\":[{\"top\":510,\"left\":215,\"width\":300,\"height\":50,\"id\":\"signature1\",\"page\":0,\"type\":\"SIGNATURE\",\"subtype\":\"CAPTURE\"}]}";
            StringContent jsonContent2 = new StringContent(jsonString2, Encoding.UTF8, "application/json");

            var response2 = myClient.PutAsync(new Uri(url) + "/packages/" + packageId + "/documents/" + documentId + "/approvals/signature1", jsonContent2).Result;
            Debug.WriteLine(response2.Content.ReadAsStringAsync().Result);

            //Delete approval

            var response3 = myClient.DeleteAsync(new Uri(url) + "/packages/" + packageId + "/documents/" + documentId + "/approvals/signature1").Result;
            Debug.WriteLine(response3.Content.ReadAsStringAsync().Result);
          
        }
    }
}
